#ifndef KFILEDIALOG_H
#define KFILEDIALOG_H

#include <QtGui/QFileDialog>
#include <QtGui/QComboBox>
#include <kurl.h>
#include <kmimetype.h>
#include "dummy.h"

class KFile {
    Q_GADGET
    Q_FLAGS(KFile::Modes)
public:
    /**
     * Modes of operation for the dialog.
     * @li @p File - Get a single file name from the user.
     * @li @p Directory - Get a directory name from the user.
     * @li @p Files - Get multiple file names from the user.
     * @li @p ExistingOnly - Never return a filename which does not exist yet
     * @li @p LocalOnly - Don't return remote filenames
     */
    enum Mode {
        File         = 1,
        Directory    = 2,
        Files        = 4,
        ExistingOnly = 8,
        LocalOnly    = 16,
        ModeMax      = 65536
    };
    Q_DECLARE_FLAGS(Modes, Mode)
};

class KFileFilterCombo : public QComboBox {
};

class KFileDialog : public QFileDialog {
public:
    static KUrl getExistingDirectoryUrl( const KUrl& startDir = KUrl(),
                                         QWidget * parent = 0,
                                         const QString& caption= QString() ) {
         return KUrl();
     }
    enum OperationMode { Other = 0, Opening, Saving };
    KFileDialog( const KUrl&, const QString&, QWidget *, QWidget* = 0 ) {
        NOT_IMPLEMENTED_MESSAGE
    }
    KFileFilterCombo *filterWidget() const {
        NOT_IMPLEMENTED_MESSAGE
        return 0;
    }
    KFile::Modes mode() const {
        NOT_IMPLEMENTED_MESSAGE
        return KFile::Modes();
    }
    void setMode( KFile::Modes) {
        NOT_IMPLEMENTED_MESSAGE
    }
    void setMimeFilter(const QStringList&, const QString& = QString() ) {
        NOT_IMPLEMENTED_MESSAGE
    }
    void setCaption(const QString &) {
        NOT_IMPLEMENTED_MESSAGE
    }
    void setOperationMode(KFileDialog::OperationMode) {
        NOT_IMPLEMENTED_MESSAGE
    }
    KUrl selectedUrl() const {
        NOT_IMPLEMENTED_MESSAGE
        return KUrl();
    }
    QString currentMimeFilter() const {
        NOT_IMPLEMENTED_MESSAGE
        return QString();
    }
    QString selectedFile() const {
        return QString();
    }
    static KUrl::List getOpenUrls( const KUrl& startDir = KUrl(),
                                   const QString& filter = QString(),
                                   QWidget *parent = 0,
                                   const QString& caption = QString() ) {
        return KUrl::List();
    }
    static KUrl getOpenUrl( const KUrl& = KUrl(),
                            const QString& = QString(),
                            QWidget* = 0,
                            const QString& = QString() ) {
        NOT_IMPLEMENTED_MESSAGE
        return KUrl();
    }
    static QString getOpenFileName( const KUrl& = KUrl(),
                                    const QString& = QString(),
                                    QWidget * = 0,
                                    const QString& = QString() ) {
        NOT_IMPLEMENTED_MESSAGE
        return QString();
    }
    static QString getSaveFileName( const KUrl& = KUrl(),
                                    const QString& = QString(),
                                    QWidget * = 0,
                                    const QString& = QString()) {
        NOT_IMPLEMENTED_MESSAGE
        return QString();
    }
};

#endif
