#ifndef __KJOBCLASSES_H
#define __KJOBCLASSES_H
#include "job.h"
#include <kjob.h>
#include <kio/udsentry.h>
#include "kfileitem.h"
#include "kio/renamedialog.h"

namespace KIO {
    enum LoadType { Reload, NoReload };
    enum JobFlag {
      DefaultFlags = 0,
      HideProgressInfo = 1,
      Resume = 2,  
      Overwrite = 4
    };
    Q_DECLARE_FLAGS(JobFlags, JobFlag)
    Q_DECLARE_OPERATORS_FOR_FLAGS(JobFlags)

    class JobUiDelegate : public KJobUiDelegate {
    public:
    virtual KIO::RenameDialog_Result askFileRename(KJob * job, const QString & caption, const QString& src, const QString & dest,
                                              KIO::RenameDialog_Mode mode, QString& newDest,
                                              KIO::filesize_t sizeSrc = (KIO::filesize_t) -1,
                                              KIO::filesize_t sizeDest = (KIO::filesize_t) -1,
                                              time_t ctimeSrc = (time_t) -1, time_t ctimeDest = (time_t) -1,
                                              time_t mtimeSrc = (time_t) -1, time_t mtimeDest = (time_t) -1) {};

        void setWindow(QWidget *window) {
            NOT_IMPLEMENTED_MESSAGE
        }
    };

    class Job : public KJob {
    public:
        void exec() {  
            NOT_IMPLEMENTED_MESSAGE
        }
        JobUiDelegate *ui() const {
            NOT_IMPLEMENTED_MESSAGE
            return 0;  
        }
    };

    class FileCopyJob : public Job {
    };

    class KIO_EXPORT StoredTransferJob : public Job {
    Q_OBJECT  
    public:   
        QByteArray data() const {
           NOT_IMPLEMENTED_MESSAGE
           return QByteArray();
        }
    };
    inline FileCopyJob *file_copy( const KUrl&, const KUrl&, int=-1,
            JobFlags= DefaultFlags ) {
        NOT_IMPLEMENTED_MESSAGE
        return 0;
    }
    inline StoredTransferJob *storedGet(const KUrl&, LoadType = NoReload,
            JobFlags = DefaultFlags) {
        NOT_IMPLEMENTED_MESSAGE
        return 0;
    }
    class PreviewJob : public KIO::Job {
    };

    inline PreviewJob *filePreview(const KFileItemList&, int, int=0, int=0,
            int=70, bool=true, bool=true, const QStringList* =0) {
        NOT_IMPLEMENTED_MESSAGE
        return 0;
    }
    inline PreviewJob *filePreview(const KUrl::List &, int, int = 0, int=0,
            int=70, bool=true, bool=true, const QStringList* =0 ) {
        NOT_IMPLEMENTED_MESSAGE
        return 0;
    }
} // end namespace
#endif
